eslint-plugin-svelte

repository·main·Indexed 19 days ago

https://github.com/sveltejs/eslint-plugin-svelte

The official ESLint plugin for Svelte. It utilizes svelte-eslint-parser to analyze Svelte files via AST, providing custom linting rules for best practices, security vulnerabilities, and possible errors in Svelte components. It includes pre-defined configurations such as base, recommended, prettier, and all, and provides specific support for SvelteKit projects and TypeScript integration.

Tokens
54.4K
Snippets
144
Records
196
Agent score
62%

What's inside eslint-plugin-svelte

  1. Introduction to eslint-plugin-svelte

    main

    eslint-plugin-svelte is the official ESLint plugin for Svelte. It uses the AST generated by svelte-eslint-parser to provide custom linting rules specifically for Svelte files.

    Important Compatibility Note: eslint-plugin-svelte and svelte-eslint-parser are incompatible with eslint-plugin-svelte3. You cannot use them in the same project.

  2. Understand the svelte/require-optimized-style-attribute rule

    main

    The svelte/require-optimized-style-attribute rule ensures that style attributes are written in a format that allows Svelte to perform granular updates.

    When Svelte can parse and optimize a style attribute, it uses element.style.setProperty() to update only the specific properties that changed. This minimizes re-renders. If the attribute is written in a way that Svelte cannot parse (e.g., using a reactive string variable or including comments), Svelte falls back to element.setAttribute('style', ...) which forces the entire style string to be re-evaluated and re-applied whenever any variable within that string changes.

    To avoid performance issues, avoid using reactive variables that contain entire CSS strings or using complex logic inside the style attribute.

    <!-- ✓ GOOD: Granular updates via setProperty -->
    <div style="font-size: 12px; color: {color}; transform: translate({x}px, {y}px);" />
    <div style:pointer-events={pointerEvents ? null : 'none'} />
    
    <!-- ✗ BAD: Full attribute re-render via setAttribute -->
    <div style="font-size: 12px; color: {color}; {transformStyle}" />
    <div style={pointerEvents === false ? 'pointer-events:none;' : ''} />
  3. Use svelte/max-lines-per-block to limit block sizes

    main

    The svelte/max-lines-per-block rule enforces a maximum number of lines within specific Svelte component blocks (<script>, <style>, or the template markup).

    This rule is a more granular alternative to ESLint's core max-lines rule. While max-lines counts every line in a .svelte file (including CSS), svelte/max-lines-per-block allows you to set independent limits for logic, markup, and styles. This prevents large <style> blocks from triggering complexity errors intended for your script or template logic.

    {
      // Only checks script and template, ignores style
      "svelte/max-lines-per-block": [
        "error",
        {
          "script": 300,
          "template": 200,
          "skipBlankLines": true,
          "skipComments": true
        }
      ]
    }
  4. Understand the `svelte/no-dom-manipulating` rule

    main

    The svelte/no-dom-manipulating rule disallows direct DOM manipulation to prevent conflicts between the actual DOM and the Svelte runtime's internal state. Direct manipulation can cause the Svelte runtime to become confused about the state of the DOM.

    How it works

    The rule specifically tracks and checks variables that have been assigned to an element via the bind:this={} directive.

    What is NOT reported

    • Function arguments passed to directives like transition: are not tracked by this rule. These are considered safe as they are typically used for well-tested, controlled purposes (like custom transitions).

    How to handle reports

    If you are intentionally manipulating the DOM and understand the risks, you can ignore the ESLint report using an eslint-disable comment.

    <script>
      /* eslint svelte/no-dom-manipulating: "error" */
      let foo, bar, show;
    
      /* ✓ GOOD: Delegating to Svelte state */
      const toggle = () => (show = !show);
    
      /* ✗ BAD: Direct DOM manipulation on bound elements */
      const remove = () => foo.remove();
      const update = () => (bar.textContent = 'Update!');
    </script>
    
    {#if show}
      <div bind:this={foo}>Foo</div>
    {/if}
    <div bind:this={bar}>
      {#if show}
        Bar
      {/if}
    </div>
    
    <button on:click={() => toggle()}>Click Me (Good)</button>
    <button on:click={() => remove()}>Click Me (Bad)</button>
    <button on:click={() => update()}>Click Me (Bad)</button>
  5. Understand the svelte/no-target-blank rule

    main

    The svelte/no-target-blank rule disallows using the target="_blank" attribute on anchor tags without accompanying rel="noopener noreferrer" attributes. This prevents security vulnerabilities in legacy browsers where a newly opened page could potentially control the original page via the window.opener property.

    Examples

    Good:

    <a href="http://example.com" target="_blank" rel="noopener noreferrer">link</a>

    Bad:

    <a href="http://example.com" target="_blank">link</a>
  6. How svelte/consistent-selector-style works

    main

    This rule compares your current CSS selectors against a list of preferred styles. It reports situations where a selector can be rewritten using a more preferred style from your configuration.

    Note on selector capabilities:

    • Class selectors (.link) can be used in almost any situation.
    • ID selectors (#link) can only be used to select a single element.
    • Type selectors (a) are only applicable when selecting all elements of that specific type.

    Because of these constraints, the rule only suggests rewrites that are functionally equivalent.

    Usage Example

    Given the preference ["type", "id", "class"]:

    <a class="link" id="firstLink">Click me!</a>
    <b class="bold cross">Text one</b>
    <i id="italic">Text three</i>
    
    <style>
      /* ✓ GOOD: Matches preferred order */
      a { color: green; }
      #firstLink { color: green; }
      .cross { color: green; }
    
      /* ✗ BAD: Can be rewritten to a more preferred style */
      
      /* Can use a type selector instead of a class */
      .link { color: red; }
    
      /* Can use an ID selector instead of a class */
      .bold { color: red; }
    
      /* Can use a type selector instead of an ID */
      #italic { color: red; }
    </style>
    <style>
      /* ✓ GOOD */
      a { color: green; }
      #firstLink { color: green; }
      .cross { color: green; }
    
      /* ✗ BAD */
      .link { color: red; } /* Can use a type selector */
      .bold { color: red; } /* Can use an ID selector */
      #italic { color: red; } /* Can use a type selector */
    </style>
  7. Use the svelte/no-unused-props rule

    main

    The svelte/no-unused-props rule warns about properties defined in Svelte $props() that are never utilized within the component code. This helps detect dead code and improves component clarity.

    It detects usage through:

    • Direct property access
    • Destructuring assignment
    • Method calls
    • Computed property access
    • Object spread
    • Constructor calls (new expressions)
    • Assignment to other variables
    • Index signatures (e.g. [key: string]: unknown)

    Note: Properties of class types are not checked for usage, as they might be used in other parts of the application.

    <!-- ✗ Bad Example: Unused property 'b' -->
    <script lang="ts">
      /* eslint svelte/no-unused-props: "error" */
      const props: { a: string; b: number } = $props();
      console.log(props.a);
    </script>
  8. Ensure the svelte/system rule is enabled

    main

    The svelte/system rule is a mandatory system rule required for eslint-plugin-svelte to function correctly. While this rule does not report any linting errors or warnings to the user, it must be active for the plugin's internal logic to operate.

    This rule is automatically included when you use the following ESLint configurations:

    • plugin:svelte/base
    • plugin:svelte/recommended
  9. Understand the svelte/no-add-event-listener rule

    main

    The svelte/no-add-event-listener rule warns against using the native addEventListener method inside Svelte components.

    Svelte uses event delegation for better performance and to ensure predictable handler execution order. When you call addEventListener directly, you bypass Svelte's event delegation mechanism. To fix this, you should use the on() helper provided by svelte/events instead of the native browser API.

    <!-- ✓ GOOD -->
    <script>
      /* eslint svelte/no-add-event-listener: "error" */
      on(window, 'resize', handler);
    </script>
    
    <!-- ✗ BAD -->
    <script>
      /* eslint svelte/no-add-event-listener: "error" */
      window.addEventListener('resize', handler);
    </script>
  10. Understand ESLint rule indicators

    main

    The eslint-plugin-svelte rules use specific icons to indicate their capabilities:

    • 🔧 Fixable: The rule can be automatically fixed using the --fix option in the ESLint command line.
    • 💡 Suggestions: Some problems reported by the rule can be manually fixed using editor suggestions.
    • Recommended: The rule is included in the plugin:svelte/recommended configuration preset.
  11. Understand the svelte/valid-style-parse rule

    main

    The svelte/valid-style-parse rule ensures that the content within <style> elements in Svelte components can be successfully parsed by the svelte-eslint-parser. It catches syntax errors in CSS or issues where an unsupported lang attribute is used, which would prevent the parser from correctly interpreting the styles.

    <!-- ✓ GOOD: Standard CSS -->
    <style>
      .class {
        font-weight: bold;
      }
    </style>
    
    <!-- ✓ GOOD: Supported preprocessor (e.g., SCSS) -->
    <style lang="scss">
      .class {
        font-weight: bold;
      }
    </style>
    
    <!-- ✗ BAD: Invalid CSS syntax -->
    <style>
      .class
        font-weight: bold;
    </style>
    
    <!-- ✗ BAD: Unsupported lang attribute -->
    <style lang="unknown">
      .class {
        font-weight: bold;
      }
    </style>
  12. Understand the versioning policy for eslint-plugin-svelte

    main

    This project follows Semantic Versioning (SemVer).

    Note on Rule Updates: Unlike ESLint's own versioning policy, eslint-plugin-svelte may add new rules to its recommended configuration during minor releases. If these new rules introduce unwanted warnings in your project, you can disable them individually in your ESLint configuration.

eslint-plugin-vue

repository·master·Indexed 26 days ago

https://github.com/vuejs/eslint-plugin-vue

The official ESLint plugin for Vue.js, providing essential linting rules to enforce best practices and coding standards in Vue Single File Components (SFCs). It enables ESLint to analyze <template> and <script> blocks within .vue files and Vue-specific code in .js files to identify syntax errors, detect incorrect usage of Vue.js Directives, and ensure compliance with the Vue.js Style Guide.

Tokens
127K
Snippets
391
Records
655
Agent score
87%

What's inside eslint-plugin-vue

  1. Understand eslint-plugin-vue rule categories and indicators

    master

    Rules in eslint-plugin-vue are categorized by their purpose and include specific indicators for how they behave:

    Rule Types

    • Possible Problems (:warning:): Rules relating to potential logic errors in your code.
    • Suggestions (:hammer:): Rules that suggest alternative ways of writing code.
    • Layout & Formatting (:lipstick:): Rules focused on code aesthetics and visual consistency.

    Fixability Indicators

    • Fixable (:wrench:): These rules can be automatically corrected using the ESLint --fix command-line option.
    • Manually Fixable (:bulb:): These rules provide editor suggestions that require manual application by the developer.
  2. Identify custom objects as Vue components

    master

    The plugin automatically detects components via standard expressions (e.g., app.component(), defineComponent(), export default {} in .vue files).

    To apply component-related rules to custom objects in non-standard files, use the // @vue/component comment immediately above the object.

    // @vue/component
    const CustomComponent = {
      name: 'custom-component',
      template: '<div></div>'
    }
  3. Use vue/no-deprecated-v-on-number-modifiers to avoid deprecated keycode modifiers

    master

    This rule disallows the use of deprecated KeyboardEvent.keyCode modifiers on the v-on directive in Vue.js 3.0.0+. Instead of using numeric key codes (e.g., .34), you should use the KeyboardEvent.key value (e.g., .page-down) or the specific key string (e.g., .9).

    This rule is included in the following preset configurations:

    • *.configs["flat/essential"]
    • *.configs["flat/strongly-recommended"]
    • *.configs["flat/recommended"]
    • "plugin:vue/essential"
    • "plugin:vue/strongly-recommended"
    • "plugin:vue/recommended"

    You can use the --fix option via the ESLint command line to automatically fix some of the problems reported by this rule.

    <template>
      <!-- ✓ GOOD -->
      <input v-on:keyup.page-down="onArrowUp">
      <input @keyup.page-down="onArrowUp">
      <input @keyup.9="onArrowUp"> <!-- 9 is KeyboardEvent.key -->
    
    
      <!-- ✗ BAD -->
      <input v-on:keyup.34="onArrowUp">
      <input @keyup.34="onArrowUp">
    </template>
  4. Use the vue/no-unused-refs rule to eliminate unused refs

    master

    The vue/no-unused-refs rule disallows defining ref attributes in <template> that are never accessed via $refs within the component's script. This helps clean up unused template references.

    Limitations: This rule cannot detect if a ref is used in other components (e.g., via mixins or nested access like $refs.x.$refs).

    <template>
      <!-- ✓ GOOD -->
      <input ref="foo" />
    
      <!-- ✗ BAD (`bar` is not used) -->
      <input ref="bar" />
    </template>
    <script>
    export default {
      mounted() {
        this.$refs.foo.value = 'foo'
      }
    }
    </script>
  5. Use the vue/no-lifecycle-after-await rule

    master

    The vue/no-lifecycle-after-await rule disallows registering lifecycle hooks (e.g., onMounted, onUpdated) after an await expression within the setup() function. In the Composition API, lifecycle hooks must be registered synchronously during the initial execution of setup() to ensure Vue can correctly track them.

    <script>
    import { onMounted } from 'vue'
    export default {
      async setup() {
        /* ✓ GOOD: Registered before await */
        onMounted(() => { /* ... */ })
    
        await doSomething()
    
        /* ✗ BAD: Registered after await */
        onMounted(() => { /* ... */ })
      }
    }
    </script>
  6. Use the vue/keyword-spacing rule

    master

    The vue/keyword-spacing rule enforces consistent spacing before and after keywords specifically within <template> expressions. It is designed to mirror the behavior of the @stylistic/keyword-spacing rule but targets Vue template syntax.

    Key features:

    • Auto-fixable: You can use the --fix option via the ESLint command line to automatically correct spacing issues.
    • Dependencies: This rule attempts to use @stylistic/eslint-plugin if installed. If not, it falls back to the ESLint core rule. If neither is available, the rule cannot be used.
  7. Configure Visual Studio Code for Vue linting

    master

    To lint .vue files in Visual Studio Code using the official dbaeumer.vscode-eslint extension, you must explicitly add vue to the eslint.validate setting, as the extension only targets *.js or *.jsx by default.

    If you are using the Vetur extension, disable its template validation to prevent duplicate linting warnings by setting vetur.validation.template to false in your settings.

    {
      "eslint.validate": [
        "javascript",
        "javascriptreact",
        "vue"
      ]
    }
  8. Use the vue/valid-define-options rule

    master

    The vue/valid-define-options rule enforces the correct usage of the defineOptions compiler macro in <script setup>. It ensures that the macro is used according to Vue's requirements for compiler-driven options.

    This rule reports the following invalid patterns:

    • Referencing locally declared variables within defineOptions (it must use a literal object or a variable declared in a separate <script> block).
    • Calling defineOptions multiple times.
    • Calling defineOptions() without any options.
    • Using type arguments (e.g., defineOptions<Type>()).
    • Including props, emits, expose, or slots inside defineOptions (these should use their respective dedicated macros instead).

    This rule is included in the following preset configurations:

    • *.configs["flat/essential"]
    • *.configs["flat/strongly-recommended"]
    • *.configs["flat/recommended"]
    • "plugin:vue/essential"
    • "plugin:vue/strongly-recommended"
    • "plugin:vue/recommended"
    <script setup>
    /* ✓ GOOD: Using a literal object */
    defineOptions({ name: 'foo' })
    </script>
    
    <script>
    /* ✓ GOOD: Using a variable from a separate script block */
    const def = { name: 'foo' }
    </script>
    <script setup>
    /* ✓ GOOD: Variable is defined outside of setup scope */
    defineOptions(def)
    </script>
    
    <script setup>
    /* ✗ BAD: Referencing a locally declared variable */
    const def = { name: 'foo' }
    defineOptions(def)
    </script>
    
    <script setup>
    /* ✗ BAD: Multiple calls */
    defineOptions({ name: 'foo' })
    defineOptions({ inheritAttrs: false })
    </script>
    
    <script setup>
    /* ✗ BAD: No options provided */
    defineOptions()
    </script>
    
    <script setup lang="ts">
    /* ✗ BAD: Using type arguments */
    defineOptions<{ name: 'Foo' }>()
    </script>
    
    <script setup>
    /* ✗ BAD: Including props in defineOptions */
    defineOptions({ props: { msg: String } })
    </script>
  9. Use the vue/no-required-prop-with-default rule

    master

    The vue/no-required-prop-with-default rule enforces that any prop declared with a default value must be optional. Since a default value allows a prop to be skipped during use, marking it as required: true is redundant and logically equivalent to an optional prop. This rule applies to both <script setup> with withDefaults and standard Options API props declarations.

    <script setup lang="ts">
    /* ✓ GOOD */
    const props = withDefaults(
      defineProps<{
        name?: string | number
        age?: number
      }>(),
      {
        name: 'Foo',
      }
    );
    
    /* ✗ BAD */
    const props = withDefaults(
      defineProps<{
        name: string | number
        age?: number
      }>(),
      {
        name: 'Foo',
      }
    );
    </script>
  10. Use the vue/valid-v-for rule

    master

    The vue/valid-v-for rule ensures that v-for directives are used correctly. It prevents common mistakes such as using arguments or modifiers on v-for, omitting the attribute value, or failing to provide a proper :key when using custom components.

    The rule reports errors when:

    • The directive has an argument (e.g., v-for:aaa).
    • The directive has a modifier (e.g., v-for.bbb).
    • The directive lacks an attribute value (e.g., v-for).
    • A custom component uses v-for but lacks a v-bind:key directive.
    • The v-bind:key directive does not use variables defined by the v-for directive (e.g., v-for="x in list" :key="foo").

    Note: This rule does not check for syntax errors (like v-for="foo" instead of alias in expr); use vue/no-parsing-error for those.

    <template>
      <!-- ✓ GOOD -->
      <div v-for="todo in todos"/>
      <MyComponent
        v-for="todo in todos"
        :key="todo.id"
      />
      <div
        v-for="todo in todos"
        :is="MyComponent"
        :key="todo.id"
      />
    
      <!-- ✗ BAD -->
      <div v-for/>
      <div v-for:aaa="todo in todos"/>
      <div v-for.bbb="todo in todos"/>
      <div
        v-for="todo in todos"
        is="MyComponent"
      />
      <MyComponent v-for="todo in todos"/>
      <MyComponent
        v-for="todo in todos"
        :key="foo"
      />
    </template>